<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision: 1843164 -->
<!-- French translation : Lucien GENTIS -->
<!-- Reviewed by : Vincent Deffontaines -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<modulesynopsis metafile="mod_dav_fs.xml.meta">

<name>mod_dav_fs</name>
<description>Impl&eacute;mente le fournisseur filesystem pour
<module>mod_dav</module></description>
<status>Extension</status>
<sourcefile>mod_dav_fs.c</sourcefile>
<identifier>dav_fs_module</identifier>

<summary>
    <p>L'activation de ce module <em>n&eacute;cessite</em> l'utilisation de
    <module>mod_dav</module>. C'est un module de support pour <module
    >mod_dav</module> et &agrave; ce titre, il permet l'acc&egrave;s &agrave; des ressources
    situ&eacute;es dans le syst&egrave;me de fichiers du serveur. Le nom formel de ce
    fournisseur est <code>filesystem</code>. Les fournisseurs supports
    de <module>mod_dav</module> sont invoqu&eacute;s via la directive
    <directive module="mod_dav">Dav</directive> :</p>

    <example><title>Exemple</title>
    <highlight language="config">
      Dav filesystem
      </highlight>
    </example>

    <p>Comme <code>filesystem</code> est le fournisseur par d&eacute;faut de
    <module>mod_dav</module>, vous pouvez vous contenter d'utiliser la
    valeur <code>On</code> comme argument de Dav.</p>
</summary>
<seealso><module>mod_dav</module></seealso>

<directivesynopsis>
<name>DavLockDB</name>
<description>Chemin de la base de donn&eacute;es des verrous DAV</description>
<syntax>DavLockDB <var>chemin fichier</var></syntax>
<default>DavLockDB DEFAULT_REL_STATEDIR/davlockdb</default>
<contextlist><context>server config</context><context>virtual
host</context>
</contextlist>
<compatibility>La valeur par défaut a été ajoutée à partir de la version 2.5.1.
du serveur HTTP Apache.</compatibility>

<usage>
    <p>La directive <directive>DavLockDB</directive> sp&eacute;cifie
    le chemin complet de la base de donn&eacute;es des verrous, sans extension.
    Si le chemin n'est pas absolu, il sera consid&eacute;r&eacute; comme relatif au
    r&eacute;pertoire d&eacute;fini par la directive <directive
    module="core">ServerRoot</directive>. L'impl&eacute;mentation de
    <module>mod_dav_fs</module> utilise une base de donn&eacute;es SDBM pour
    surveiller les verrous utilisateurs.</p>

    <!-- XXX: someone should add that tool to the support directory...
    The utility <code>modules/dav/util/lockview</code> can be used from
    the server to display all locks in a lock database.</p> -->

    <example><title>Exemple</title>
    <highlight language="config">
      DavLockDB var/DavLock
      </highlight>
    </example>

    <p>Les utilisateur et groupe sous lesquels Apache s'ex&eacute;cute et qui
    sont respectivement d&eacute;finis par les directives <directive
    module="mod_unixd">User</directive> et <directive
    module="mod_unixd">Group</directive> doivent pouvoir &eacute;crire dans le
    r&eacute;pertoire qui contient le fichier de la base de donn&eacute;es des
    verrous. Pour des raisons de s&eacute;curit&eacute;, il est recommand&eacute; de cr&eacute;er un
    r&eacute;pertoire d&eacute;di&eacute; &agrave; la base de donn&eacute;es des verrous, plut&ocirc;t que de
    modifier les permissions d'un r&eacute;pertoire existant. Dans l'exemple
    ci-dessus, Apache va cr&eacute;er des fichiers dans le r&eacute;pertoire
    <code>var/</code>, lui-m&ecirc;me sous-r&eacute;pertoire du r&eacute;pertoire d&eacute;fini par
    la directive <directive
    module="core">ServerRoot</directive>, avec le nom de base
    <code>DavLock</code> suivi d'une extension choisie par le
    serveur.</p>

    <note><title>Valeur par défaut</title>
    <p>A partir de la version 2.5.1. de httpd, une valeur par défaut a été codée
    en dur et correspond à un chemin relatif par rapport au répertoire des
    fichiers d'état (lui-même défini via la directive <directive
    module="core">DefaultStateDir</directive>).</p>
    </note>

</usage>
</directivesynopsis>

</modulesynopsis>

