<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision : 772682 -->
<!-- French translation : Lucien GENTIS -->
<!-- $LastChangedRevision: 2009050301 $ -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<modulesynopsis metafile="mod_request.xml.meta">

<name>mod_request</name>
<description>Filtres permettant de traiter et de mettre à disposition
les corps de requêtes HTTP</description>
<status>Base</status>
<sourcefile>mod_request.c</sourcefile>
<identifier>request_module</identifier>
<compatibility>Disponible depuis la version 2.3 d'Apache</compatibility>

<directivesynopsis>
<name>KeptBodySize</name>
<description>Conserve le corps de la requête à concurrence de la taille
maximale spécifiée, pour une utilisation éventuelle par des filtres
comme mod_include.</description>
<syntax>KeptBodySize <var>taille maximale en octets</var></syntax>
<default>KeptBodySize 0</default>
<contextlist><context>directory</context>
</contextlist>

<usage>
    <p>Dans une situation normale, les gestionnaires de requête tels que
    le gestionnaire par défaut des fichiers statiques suppriment le
    corps de la requête s'il n'est pas nécessaire au gestionnaire de
    requête. Il en résulte que les filtres comme mod_include sont
    limités à des requêtes <code>GET</code> lors de l'inclusion d'autres
    URLs en tant que sous-requêtes, et ceci même si la requête originale
    était une requête <code>POST</code>, car le corps de la requête a
    été supprimé et n'est donc plus disponible une fois le traitement du
    filtre mis en oeuvre.</p>

    <p>Lorsque l'argument de cette directive a une valeur supérieure à
    zéro, les gestionnaires de requête qui suppriment habituellement les
    corps de requête vont alors conserver ces corps de requête, à
    concurrence de la taille maximale spécifiée, pour être
    éventuellement utilisés par des filtres. Dans le cas du filtre
    mod_include, une tentative de requête <code>POST</code> pour un
    fichier shtml statique se traduira par des sous-requêtes
    <code>POST</code>, et non par des sous-requêtes <code>GET</code>
    comme avant.</p>

    <p>Cette fonctionnalité permet de découper des pages web complexes
    et des applications web en petits éléments individuels, et de
    combiner ces éléments avec la structure de la page web sous-jacente
    en utilisant <module>mod_include</module>. Les éléments peuvent se
    présenter sous la forme de programmes CGI, de langages de scripts,
    ou d'URLs issues d'un mandataire inverse dans l'espace d'URL d'un
    autre serveur en utilisant <module>mod_proxy</module>.</p>

    <p><strong>Note :</strong> Chaque requête dont le corps est ainsi
    conservé doit être enregistrée temporairement en mémoire vive
    jusqu'à la fin du traitement de la requête. Il faut donc s'assurer
    que la mémoire RAM du serveur est suffisante pour pouvoir supporter
    la charge induite. L'utilisation de cette directive doit être
    limitée à certaines portions de votre espace d'URL bien précises qui
    le nécessitent, et en spécifiant comme taille maximale une valeur la
    plus petite possible, mais tout de même suffisante pour un corps de
    requête.</p>

    <p>Si la taille de la requête envoyée par le client dépasse la taille
    maximale autorisée par cette directive, le serveur renverra l'erreur
    <code>413 Request Entity Too Large</code>.</p>

</usage>

<seealso>la documentation de <a href="mod_include.html">mod_include</a></seealso>
<seealso>la documentation de <a href="mod_auth_form.html">mod_auth_form</a></seealso>
</directivesynopsis>

</modulesynopsis>
