<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision : 1700418 -->
<!-- French translation : Lucien GENTIS -->
<!-- $LastChangedRevision: 2015091301 $ -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<modulesynopsis metafile="mod_socache_memcache.xml.meta">

<name>mod_socache_memcache</name>
<description>Fournisseur de cache d'objets partagés basé sur Memcache.</description>
<status>Extension</status>
<sourcefile>mod_socache_memcache.c</sourcefile>
<identifier>socache_memcache_module</identifier>

<summary>
    <p>Le module <code>mod_socache_memcache</code> est un fournisseur de cache
    d'objets partagés qui permet la création et l'accès à un cache
    maintenu par le système de mise en cache d'objets en mémoire
    distribuée à hautes performances <a
    href="http://memcached.org/">memcached</a>.
    </p>

    <p>Cette méthode "create" du fournisseur de cache d'objets partagés
    requiert une liste de spécifications hôte/port en cache mémoire
    séparées par des virgules. Si vous utilisez ce fournisseur en
    dans la configuration d'autres modules (comme
    <directive module="mod_ssl">SSLSessionCache</directive>), vous devez
    fournir la liste des serveurs sous la forme du paramètre optionnel
    "arg".</p>

     <highlight language="config">
         SSLSessionCache memcache:memcache.example.com:12345,memcache2.example.com:12345
     </highlight>

    <p>Vous trouverez des détails à propos des autres fournisseurs de
    cache d'objets partagés <a href="../socache.html">ici</a>.
    </p>

</summary>

<directivesynopsis>
<name>MemcacheConnTTL</name>
<description>Durée de conservation des connexions inactives</description>
<syntax>MemcacheConnTTL <em>num[units]</em></syntax>
<default>MemcacheConnTTL 15s</default>
<contextlist>
<context>server config</context>
<context>virtual host</context>
</contextlist>
<compatibility>Disponible à partir de la version 2.4.17 du serveur HTTP
Apache.</compatibility>

<usage>

    <p>Définit la durée pendant laquelle les connexions
    inactives avec le(s) serveur(s) memcache seront conservées
    (plateformes threadées seulement).</p>
    
    <p>Les valeurs valides de la directive
    <directive>MemcacheConnTTL</directive> sont des durées d'une heure
    maximum. La valeur 0 signifie une absence de péremption</p>

    <note><p>L'unité par défaut pour ce délai est la seconde, mais vous
    pouvez ajouter un suffixe pour spécifier une unité différente ; ms
    pour milliseconde, s pour seconde, min pour minute et h pour heure..
    </p></note>

    <p>Dans les versions antérieures à 2.4.17, ce délai était codé en
    dur et sa valeur était 600 microsecondes. La valeur la plus proche
    de cette ancienne valeur pour la directive
    <directive>MemcacheConnTTL</directive> est donc 1ms.</p>

    <example>
    <highlight language="config">
# Définition d'un délai de 10 minutes
MemcacheConnTTL 10min
# Définition d'un délai de 60 secondes
MemcacheConnTTL 60
    </highlight>
    </example>

</usage>
</directivesynopsis>

</modulesynopsis>
