<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision : 1584572 -->
<!-- French translation : Lucien GENTIS -->
<!-- $LastChangedRevision: 2014040501 $ -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<modulesynopsis metafile="mod_suexec.xml.meta">

<name>mod_suexec</name>
<description>Permet l'exécution des scripts CGI sous l'utilisateur et
le groupe spécifiés</description>
<status>Extension</status>
<sourcefile>mod_suexec.c</sourcefile>
<identifier>suexec_module</identifier>


<summary>
    <p>Ce module, en combinaison avec son programme support
    <program>suexec</program>, permet l'exécution des scripts CGI sous
    l'utilisateur et le groupe spécifiés.</p>
</summary>

<seealso><a href="../suexec.html">Support de SuEXEC</a></seealso>

<directivesynopsis>

<name>SuexecUserGroup</name>
<description>L'utilisateur et le groupe sous lesquels les programmes CGI
doivent s'exécuter</description>
<syntax>SuexecUserGroup <em>Utilisateur Groupe</em></syntax>
<contextlist><context>server config</context>
<context>virtual host</context></contextlist>

<usage>
    <p>La directive <directive>SuexecUserGroup</directive> permet de
    spécifier l'utilisateur et le groupe sous lesquels les programmes
    CGI doivent s'exécuter. Les requêtes non CGI seront toujours
    traitées avec l'utilisateur spécifié par la directive <directive
    module="mod_unixd">User</directive>.</p>

    <example>
    <title>Exemple</title>
    <highlight language="config">
    SuexecUserGroup nobody nogroup
    </highlight>
    </example>

    <p>Le démarrage va échouer si cette
    directive est spécifiée et si la fonctionnalité suEXEC est
    désactivée.</p>

</usage>

<seealso><directive module="mod_unixd">Suexec</directive></seealso>
</directivesynopsis>

</modulesynopsis>

