<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision : 1620075 -->
<!-- French translation : Lucien GENTIS -->
<!-- $LastChangedRevision: 2015011801 $ -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<modulesynopsis metafile="mod_systemd.xml.meta">

<name>mod_systemd</name>
<description>Fournit un support am&eacute;lior&eacute; pour l'int&eacute;gration de systemd</description>
<status>Extension</status>
<sourcefile>mod_systemd.c</sourcefile>
<identifier>systemd_module</identifier>

<summary>
    <p>Ce module impl&eacute;mente le support de l'int&eacute;gration de systemd. Il
    permet de d&eacute;marrer httpd en temps que service avec le param&egrave;tre de
    systemd <code>Type=notify</code> (voir la page de manuel
    systemd.service(5) pour plus de d&eacute;tails). Il ajoute aussi des
    statistiques &agrave; la sortie de la commande <code>systemctl
    status</code>, et fournit diverses directives pour l'int&eacute;gration de
    systemd.
    </p>
</summary>

<directivesynopsis>
<name>IdleShutdown</name>
<description>Permet d'arr&ecirc;ter httpd lorsque qu'il est inactif pendant un
certain temps.</description>
<syntax>IdleShutdown seconds</syntax>
<default>IdleShutdown 0</default>
<contextlist><context>server config</context></contextlist>

<usage>
    <p>La directive <directive>IdleShutdown</directive> permet d'arr&ecirc;ter
    httpd lorsque qu'il est inactif pendant un certain temps. Ce statut
    d'inactivit&eacute; se base sur le nombre d'octets envoy&eacute;s ; par cons&eacute;quent, si
    aucun octet n'est envoy&eacute; pendant le temps sp&eacute;cifi&eacute; par cette
    directive, httpd sera arr&ecirc;t&eacute;. Par d&eacute;faut, IdleShutdown est d&eacute;finie &agrave;
    0, ce qui signifie que cette fonctionnalit&eacute; est d&eacute;sactiv&eacute;e.
    </p>

    <p>Cette fonctionnalit&eacute; prend tout son sens en combinaison avec
    l'activation du socket systemd (voir la page de manuel
    systemd.socket(5)). En effet, lorsque httpd est d&eacute;marr&eacute; par systemd
    suite &agrave; l'arriv&eacute;e d'une ou plusieurs requ&ecirc;tes HTTP, cette directive
    vous permet d'arr&ecirc;ter httpd automatiquement lorsque toutes les
    requ&ecirc;tes ont &eacute;t&eacute; trait&eacute;es.
    </p>

    <note type="warning"><title>Particularit&eacute; de cette impl&eacute;mentation</title><p>
    De par la conception de cette impl&eacute;mentation, l'inactivit&eacute; de httpd
    n'est v&eacute;rifi&eacute;e que toutes les 10 secondes, ce qui signifie que si
    vous sp&eacute;cifiez <code>IdleShutdown 14</code>, httpd ne s'arr&ecirc;tera
    qu'apr&egrave;s 20 secondes d'inactivit&eacute;.
    </p></note>
</usage>
</directivesynopsis>


</modulesynopsis>
